﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using VSGridMapF35;
using static VSGridMapF35.ClsPsysCell;

namespace VS2017CSF35
{
    public partial class FrmMain : Form
    {
        string NwLn = System.Environment.NewLine;

        public FrmMain()
        {
            InitializeComponent();
        }

        private void FrmMain_Load(object sender, EventArgs e)
        {

        }

        private void CmdLoadJSON_Click(object sender, EventArgs e)
        {
            string jsonStr = "";
            jsonStr += "{" + NwLn;
            jsonStr += "  \"Type\": \"BackGroundMap\"," + NwLn;
            jsonStr += "  \"Items\": [" + NwLn;
            jsonStr += "    {\"IniPosX\": 1, \"IniPosY\": 1,  \"EndPosX\": 4,  \"EndPosY\": 4,  \"BackColorHTML\": \"#FF3366\"}," + NwLn;
            jsonStr += "    {\"IniPosX\": 5, \"IniPosY\": 5,  \"EndPosX\": 10, \"EndPosY\": 7,  \"BackColorHTML\": \"#3333CC\"}," + NwLn;
            jsonStr += "    {\"IniPosX\": 3, \"IniPosY\": 10, \"EndPosX\": 15, \"EndPosY\": 13, \"BackColorHTML\": \"#66ff99\"}" + NwLn;
            jsonStr += "  ]" + NwLn;
            jsonStr += "}" + NwLn;
            PsysGridMap1.BackgroundMapJSON = jsonStr;
            PsysGridMap1.Redraw();
        }

        private void CmdLoadXML_Click(object sender, EventArgs e)
        {
            string xmlStr = "";
            xmlStr += "<?xml version=\"1.0\" encoding=\"utf-16\"?>" + NwLn;
            xmlStr += "<ClsBackgroundGrid xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">" + NwLn;
            xmlStr += "  <Type>BackgroundGrid</Type>" + NwLn;
            xmlStr += "  <Items>" + NwLn;
            xmlStr += "    <ClsBackgroundGridItem>" + NwLn;
            xmlStr += "      <IniPosX>1</IniPosX>" + NwLn;
            xmlStr += "      <IniPosY>1</IniPosY>" + NwLn;
            xmlStr += "      <EndPosX>4</EndPosX>" + NwLn;
            xmlStr += "      <EndPosY>3</EndPosY>" + NwLn;
            xmlStr += "      <BackColorHTML>#ff6699</BackColorHTML>" + NwLn;
            xmlStr += "    </ClsBackgroundGridItem>" + NwLn;
            xmlStr += "    <ClsBackgroundGridItem>" + NwLn;
            xmlStr += "      <IniPosX>4</IniPosX>" + NwLn;
            xmlStr += "      <IniPosY>1</IniPosY>" + NwLn;
            xmlStr += "      <EndPosX>5</EndPosX>" + NwLn;
            xmlStr += "      <EndPosY>5</EndPosY>" + NwLn;
            xmlStr += "      <BackColorHTML>#cc6600</BackColorHTML>" + NwLn;
            xmlStr += "    </ClsBackgroundGridItem>" + NwLn;
            xmlStr += "  </Items>" + NwLn;
            xmlStr += "</ClsBackgroundGrid>";

            PsysGridMap1.BackgroundMapXML = xmlStr;
            PsysGridMap1.Redraw();

        }

        private void CmdLoadCells_Click(object sender, EventArgs e)
        {
            PsysGridMap1.DraggingActive = false;
            PsysGridMap1.CellsTitleAlign = ContentAlignment.TopLeft;
            PsysGridMap1.BackgroundImageLayout = ImageLayout.None;
            for (int xx = 1; xx <= 5; xx++)
            {
                for (int yy = 1; yy <= 5; yy++)
                {
                    PsysGridMap1.SetCell(
                        string.Concat(xx.ToString(), ",", yy.ToString()),
                        xx,
                        yy,
                        string.Concat(xx.ToString(), ",", yy.ToString())
                        );
                    PsysGridMap1.GetCell(xx, yy).CellBackColor = Color.White;
                    PsysGridMap1.GetCell(xx, yy).CellForeColor = Color.Black;
                }
            }

            PsysGridMap1.GetCell(2, 2).CornerNote = true;
            PsysGridMap1.GetCell(2, 2).CornerSize = 6;
            PsysGridMap1.GetCell(2, 2).CornerPosition = EnumCornerPosition.LeftTop;

            PsysGridMap1.GetCell(4, 2).CornerNote = true;
            PsysGridMap1.GetCell(4, 2).CornerSize = 6;
            PsysGridMap1.GetCell(4, 2).CornerPosition = EnumCornerPosition.RightTop;
            PsysGridMap1.GetCell(4, 2).CornerColor = System.Drawing.Color.Red;

            PsysGridMap1.GetCell(2, 4).CornerNote = true;
            PsysGridMap1.GetCell(2, 4).CornerSize = 6;
            PsysGridMap1.GetCell(2, 4).CornerPosition = EnumCornerPosition.LeftBottom;

            PsysGridMap1.GetCell(4, 4).CornerNote = true;
            PsysGridMap1.GetCell(4, 4).CornerSize = 6;
            PsysGridMap1.GetCell(4, 4).CornerPosition = EnumCornerPosition.RightBottom;
            PsysGridMap1.GetCell(4, 4).CornerColor = System.Drawing.Color.Green;

            PsysGridMap1.Redraw();

            ClsPsysCell oCell = new ClsPsysCell();
            oCell.CellX = 7;
            oCell.CellY = 4;
            oCell.ID = "myID";
            oCell.Title = "Obj";
            oCell.Data = this;
            oCell.CellBackColor = Color.Bisque;
            oCell.CellForeColor = Color.Black;
            oCell.CornerNote = true;
            oCell.CornerSize = 7;
            oCell.CornerPosition = EnumCornerPosition.RightTop;
            oCell.CornerColor = Color.Red;

            PsysGridMap1.SetCell(oCell);

        }

        private void CmdRemoveAll_Click(object sender, EventArgs e)
        {
            PsysGridMap1.RemoveAllCells();
        }

        private void CmdBackgroungCell_Click(object sender, EventArgs e)
        {

            if (PsysGridMap1.GetCell(1, 1) != null)
            {
                PsysGridMap1.GetCell(1, 1).CellBackgroundImage = PicBgCell.Image;
                PsysGridMap1.GetCell(1, 1).CellBackgroundImagePosition = ContentAlignment.TopLeft;
            }
            if (PsysGridMap1.GetCell(3, 1) != null)
            {
                PsysGridMap1.GetCell(3, 1).CellBackgroundImage = PicBgCell.Image;
                PsysGridMap1.GetCell(3, 1).CellBackgroundImagePosition = ContentAlignment.TopCenter;
            }
            if (PsysGridMap1.GetCell(5, 1) != null)
            {
                PsysGridMap1.GetCell(5, 1).CellBackgroundImage = PicBgCell.Image;
                PsysGridMap1.GetCell(5, 1).CellBackgroundImagePosition = ContentAlignment.TopRight;
            }

            if (PsysGridMap1.GetCell(1, 3) != null)
            {
                PsysGridMap1.GetCell(1, 3).CellBackgroundImage = PicBgCell.Image;
                PsysGridMap1.GetCell(1, 3).CellBackgroundImagePosition = ContentAlignment.MiddleLeft;
            }
            if (PsysGridMap1.GetCell(3, 3) != null)
            {
                PsysGridMap1.GetCell(3, 3).CellBackgroundImage = PicBgCell.Image;
                PsysGridMap1.GetCell(3, 3).CellBackgroundImagePosition = ContentAlignment.MiddleCenter;
            }
            if (PsysGridMap1.GetCell(5, 3) != null)
            {
                PsysGridMap1.GetCell(5, 3).CellBackgroundImage = PicBgCell.Image;
                PsysGridMap1.GetCell(5, 3).CellBackgroundImagePosition = ContentAlignment.MiddleRight;
            }

            if (PsysGridMap1.GetCell(1, 5) != null)
            {
                PsysGridMap1.GetCell(1, 5).CellBackgroundImage = PicBgCell.Image;
                PsysGridMap1.GetCell(1, 5).CellBackgroundImagePosition = ContentAlignment.BottomLeft;
            }
            if (PsysGridMap1.GetCell(3, 5) != null)
            {
                PsysGridMap1.GetCell(3, 5).CellBackgroundImage = PicBgCell.Image;
                PsysGridMap1.GetCell(3, 5).CellBackgroundImagePosition = ContentAlignment.BottomCenter;
            }
            if (PsysGridMap1.GetCell(5, 5) != null)
            {
                PsysGridMap1.GetCell(5, 5).CellBackgroundImage = PicBgCell.Image;
                PsysGridMap1.GetCell(5, 5).CellBackgroundImagePosition = ContentAlignment.BottomRight;
            }

            PsysGridMap1.Redraw();
        }

        private void PsysGridMap1_Open(object sender, EventArgs e)
        {
            //### SET LICENSE ###
            PsysGridMap1.LicenseName = "Your Name";
            PsysGridMap1.LicenseAddress = "Your Address";
            PsysGridMap1.LicenseCity = "Your City";
            PsysGridMap1.LicenseCode = "XXXXXX-XXXXXX-XXXXXX-XXXXXX";
        }

        private void CmdBeach_Click(object sender, EventArgs e)
        {

            PsysGridMap1.RemoveAllCells();
            PsysGridMap1.CellsTitleAlign = ContentAlignment.TopLeft;
            PsysGridMap1.MapBackColor = Color.Beige;
            PsysGridMap1.ForeColor = Color.Black;

            ClsPsysCell oCell = new ClsPsysCell();
            Font f = new System.Drawing.Font(this.Font.FontFamily, 7);
            PsysGridMap1.CellsFont = f;
            PsysGridMap1.TotalCellsX = 29;
            PsysGridMap1.TotalCellsY = 20;
            PsysGridMap1.CellWidth = 25;
            PsysGridMap1.CellHeight = 25;
        

            //### Load a BackgroundMap from a JSON string ###
            string jStr = "";
            jStr = jStr + "{" + NwLn;
            jStr = jStr + "  \"Type\": \"BackGroundMap\"," + NwLn;
            jStr = jStr + "  \"Items\": [" + NwLn;
            jStr = jStr + "    {\"IniPosX\": 1, \"IniPosY\": 1,  \"EndPosX\": 29,  \"EndPosY\": 2,  \"BackColorHTML\": \"#C1F0FE\"}," + NwLn;
            jStr = jStr + "    {\"IniPosX\": 10, \"IniPosY\": 3,  \"EndPosX\": 15, \"EndPosY\": 3,  \"BackColorHTML\": \"#C1F0FE\"}," + NwLn;
            jStr = jStr + "    {\"IniPosX\": 25, \"IniPosY\": 3,  \"EndPosX\": 29, \"EndPosY\": 3,  \"BackColorHTML\": \"#C1F0FE\"}," + NwLn;
            jStr = jStr + "    {\"IniPosX\": 10, \"IniPosY\": 7, \"EndPosX\": 11, \"EndPosY\": 20, \"BackColorHTML\": \"#E0E6E6\"}," + NwLn;
            jStr = jStr + "    {\"IniPosX\": 19, \"IniPosY\": 7, \"EndPosX\": 20, \"EndPosY\": 20, \"BackColorHTML\": \"#E0E6E6\"}," + NwLn;
            jStr = jStr + "    {\"IniPosX\": 1, \"IniPosY\": 19, \"EndPosX\": 29, \"EndPosY\": 20, \"BackColorHTML\": \"#E0E6E6\"}," + NwLn;
            jStr = jStr + "    {\"IniPosX\": 10, \"IniPosY\": 15, \"EndPosX\": 20, \"EndPosY\": 20, \"BackColorHTML\": \"#E0E6E6\"}," + NwLn;
            jStr = jStr + "    {\"IniPosX\": 12, \"IniPosY\": 17, \"EndPosX\": 18, \"EndPosY\": 20, \"BackColorHTML\": \"#A97735\"}" + NwLn;
            jStr = jStr + "  ]" + NwLn;
            jStr = jStr + "}" + NwLn;
            PsysGridMap1.BackgroundMapJSON = jStr;


            //### Load a some Cells ###
            Color cRed = System.Drawing.Color.IndianRed;
            Color cGreen = System.Drawing.Color.LightGreen;

            PsysGridMap1.SetCell(1, 2, 17, "1").CellBackColor = cGreen;
            PsysGridMap1.SetCell(2, 4, 17, "2").CellBackColor = cRed;
            PsysGridMap1.SetCell(3, 6, 17, "3").CellBackColor = cGreen;
            PsysGridMap1.SetCell(4, 8, 17, "4").CellBackColor = cRed;
            PsysGridMap1.SetCell(5, 2, 15, "5").CellBackColor = cRed;
            PsysGridMap1.SetCell(6, 4, 15, "6").CellBackColor = cRed;
            PsysGridMap1.SetCell(7, 6, 15, "7").CellBackColor = cGreen;
            PsysGridMap1.SetCell(8, 8, 15, "8").CellBackColor = cGreen;
            PsysGridMap1.SetCell(9, 2, 13, "9").CellBackColor = cGreen;
            PsysGridMap1.SetCell(10, 4, 13, "10").CellBackColor = cGreen;
            PsysGridMap1.SetCell(11, 6, 13, "11").CellBackColor = cGreen;
            PsysGridMap1.SetCell(12, 8, 13, "12").CellBackColor = cRed;
            PsysGridMap1.SetCell(13, 2, 11, "13").CellBackColor = cRed;
            PsysGridMap1.SetCell(14, 4, 11, "14").CellBackColor = cRed;
            PsysGridMap1.SetCell(15, 6, 11, "15").CellBackColor = cGreen;
            PsysGridMap1.SetCell(16, 8, 11, "16").CellBackColor = cGreen;
            PsysGridMap1.SetCell(17, 2, 9, "17").CellBackColor = cGreen;
            PsysGridMap1.SetCell(18, 4, 9, "18").CellBackColor = cGreen;
            PsysGridMap1.SetCell(19, 6, 9, "19").CellBackColor = cRed;
            PsysGridMap1.SetCell(20, 8, 9, "20").CellBackColor = cRed;
            PsysGridMap1.SetCell(21, 2, 7, "21").CellBackColor = cRed;
            PsysGridMap1.SetCell(22, 4, 7, "22").CellBackColor = cGreen;
            PsysGridMap1.SetCell(23, 6, 7, "23").CellBackColor = cGreen;
            PsysGridMap1.SetCell(24, 8, 7, "24").CellBackColor = cGreen;

            PsysGridMap1.SetCell(25, 13, 7, "25").CellBackColor = cGreen;
            PsysGridMap1.SetCell(26, 15, 7, "26").CellBackColor = cRed;
            PsysGridMap1.SetCell(27, 17, 7, "27").CellBackColor = cRed;
            PsysGridMap1.SetCell(28, 13, 9, "28").CellBackColor = cGreen;
            PsysGridMap1.SetCell(29, 15, 9, "29").CellBackColor = cGreen;
            PsysGridMap1.SetCell(30, 17, 9, "30").CellBackColor = cGreen;
            PsysGridMap1.SetCell(31, 13, 11, "31").CellBackColor = cGreen;
            PsysGridMap1.SetCell(32, 15, 11, "32").CellBackColor = cRed;
            PsysGridMap1.SetCell(33, 17, 11, "33").CellBackColor = cRed;
            PsysGridMap1.SetCell(34, 13, 13, "34").CellBackColor = cRed;
            PsysGridMap1.SetCell(35, 15, 13, "35").CellBackColor = cGreen;
            PsysGridMap1.SetCell(36, 17, 13, "36").CellBackColor = cGreen;

            PsysGridMap1.SetCell(37, 22, 17, "37").CellBackColor = cGreen;
            PsysGridMap1.SetCell(38, 24, 17, "38").CellBackColor = cGreen;
            PsysGridMap1.SetCell(39, 26, 17, "39").CellBackColor = cRed;
            PsysGridMap1.SetCell(40, 28, 17, "40").CellBackColor = cGreen;
            PsysGridMap1.SetCell(41, 22, 15, "41").CellBackColor = cRed;
            PsysGridMap1.SetCell(42, 24, 15, "42").CellBackColor = cGreen;
            PsysGridMap1.SetCell(43, 26, 15, "43").CellBackColor = cRed;
            PsysGridMap1.SetCell(44, 28, 15, "44").CellBackColor = cGreen;
            PsysGridMap1.SetCell(45, 22, 13, "45").CellBackColor = cRed;
            PsysGridMap1.SetCell(46, 24, 13, "46").CellBackColor = cGreen;
            PsysGridMap1.SetCell(47, 26, 13, "47").CellBackColor = cGreen;
            PsysGridMap1.SetCell(48, 28, 13, "48").CellBackColor = cRed;
            PsysGridMap1.SetCell(49, 22, 11, "49").CellBackColor = cRed;
            PsysGridMap1.SetCell(50, 24, 11, "50").CellBackColor = cGreen;
            PsysGridMap1.SetCell(51, 26, 11, "51").CellBackColor = cGreen;
            PsysGridMap1.SetCell(52, 28, 11, "52").CellBackColor = cGreen;
            PsysGridMap1.SetCell(53, 22, 9, "53").CellBackColor = cGreen;
            PsysGridMap1.SetCell(54, 24, 9, "54").CellBackColor = cRed;
            PsysGridMap1.SetCell(55, 26, 9, "55").CellBackColor = cGreen;
            PsysGridMap1.SetCell(56, 28, 9, "56").CellBackColor = cRed;
            PsysGridMap1.SetCell(57, 22, 7, "57").CellBackColor = cGreen;
            PsysGridMap1.SetCell(58, 24, 7, "58").CellBackColor = cGreen;
            PsysGridMap1.SetCell(59, 26, 7, "59").CellBackColor = cRed;
            PsysGridMap1.SetCell(60, 28, 7, "60").CellBackColor = cGreen;

            PsysGridMap1.SetCell(61, 3, 5, "61s").CellBackColor = cGreen;
            PsysGridMap1.SetCell(62, 5, 5, "62s").CellBackColor = cRed;
            PsysGridMap1.SetCell(63, 7, 5, "63s").CellBackColor = cGreen;
            PsysGridMap1.SetCell(64, 9, 5, "64s").CellBackColor = cGreen;

            PsysGridMap1.SetCell(65, 12, 5, "65s").CellBackColor = cGreen;
            PsysGridMap1.SetCell(66, 14, 5, "66s").CellBackColor = cGreen;
            PsysGridMap1.SetCell(67, 16, 5, "67s").CellBackColor = cGreen;
            PsysGridMap1.SetCell(68, 18, 5, "68s").CellBackColor = cGreen;

            PsysGridMap1.SetCell(69, 21, 5, "69s").CellBackColor = cGreen;
            PsysGridMap1.SetCell(70, 23, 5, "70s").CellBackColor = cRed;
            PsysGridMap1.SetCell(71, 25, 5, "71s").CellBackColor = cRed;
            PsysGridMap1.SetCell(72, 27, 5, "72s").CellBackColor = cRed;

            PsysGridMap1.Redraw();
        }

        private void CmdActiveDragging_Click(object sender, EventArgs e)
        {
            PsysGridMap1.DraggingActive = true;
        }

        private void CmdDeactiveDragging_Click(object sender, EventArgs e)
        {
            PsysGridMap1.DraggingActive = false;
        }

        private void CmdLoadUSA_Click(object sender, EventArgs e)
        {
            PsysGridMap1.TotalCellsX = 12;
            PsysGridMap1.TotalCellsY = 8;
            PsysGridMap1.CellWidth = 40;
            PsysGridMap1.CellHeight = 40;
            PsysGridMap1.RemoveAllCells();
            PsysGridMap1.MapBackgroundImage = null;
            PsysGridMap1.MapBackColor = Color.Azure;
            PsysGridMap1.MapBorderColor = Color.Silver;
            PsysGridMap1.ForeColor = Color.Black;
            PsysGridMap1.BackgroundMapJSON = "";
            PsysGridMap1.BackgroundMapXML = "";

            PsysGridMap1.CellsTitleAlign = ContentAlignment.MiddleCenter;

            Font f = new System.Drawing.Font(this.Font.FontFamily, 12, FontStyle.Italic);
            PsysGridMap1.CellsFont = f;

            PsysGridMap1.SetCell(1, 1, 1, "AK").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(2, 12, 1, "ME").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(3, 11, 2, "VT").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(4, 12, 2, "NH").CellBackColor = RandomColor();

            PsysGridMap1.SetCell(5, 2, 3, "WA").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(6, 3, 3, "ID").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(7, 4, 3, "MT").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(8, 5, 3, "ND").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(9, 6, 3, "MN").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(10, 7, 3, "IL").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(11, 8, 3, "WI").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(12, 9, 3, "MI").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(13, 10, 3, "NY").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(14, 11, 3, "RI").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(15, 12, 3, "MA").CellBackColor = RandomColor();

            PsysGridMap1.SetCell(16, 2, 4, "OR").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(17, 3, 4, "NV").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(18, 4, 4, "WY").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(19, 5, 4, "SD").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(20, 6, 4, "IA").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(21, 7, 4, "IN").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(22, 8, 4, "OH").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(23, 9, 4, "PA").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(24, 10, 4, "NJ").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(25, 11, 4, "CT").CellBackColor = RandomColor();

            PsysGridMap1.SetCell(26, 2, 5, "CA").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(27, 3, 5, "UT").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(28, 4, 5, "CO").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(29, 5, 5, "NE").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(30, 6, 5, "MO").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(31, 7, 5, "KY").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(32, 8, 5, "WV").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(33, 9, 5, "VA").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(34, 10, 5, "MD").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(35, 11, 5, "DE").CellBackColor = RandomColor();

            PsysGridMap1.SetCell(36, 3, 6, "AZ").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(37, 4, 6, "NM").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(38, 5, 6, "KS").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(39, 6, 6, "AR").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(40, 7, 6, "TN").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(41, 8, 6, "NC").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(42, 9, 6, "SC").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(43, 10, 6, "DC").CellBackColor = RandomColor();

            PsysGridMap1.SetCell(44, 5, 7, "OK").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(45, 6, 7, "LA").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(46, 7, 7, "MS").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(47, 8, 7, "AL").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(48, 9, 7, "GA").CellBackColor = RandomColor();

            PsysGridMap1.SetCell(49, 1, 8, "HI").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(50, 5, 8, "TX").CellBackColor = RandomColor();
            PsysGridMap1.SetCell(51, 10, 8, "FL").CellBackColor = RandomColor();

            PsysGridMap1.Redraw();
        }

        Random rnd = new Random();
        private Color RandomColor()
        {
            return Color.FromArgb(255, rnd.Next(255), rnd.Next(255), rnd.Next(255));
        }

        private void CmdLoadBeachImage_Click(object sender, EventArgs e)
        {

            //Get images from Resource
            Image imgBeach = VS2017CSF35.Properties.Resources.ResourceManager.GetObject("imgBeach") as Image;
            Image imgPosAzure = VS2017CSF35.Properties.Resources.ResourceManager.GetObject("imgPosAzure") as Image;
            Image imgPosYellow = VS2017CSF35.Properties.Resources.ResourceManager.GetObject("imgPosYellow") as Image;
            Image imgLettino = VS2017CSF35.Properties.Resources.ResourceManager.GetObject("imgLettino") as Image;

            //Set GridMap

            PsysGridMap1.TotalCellsX = 28;
            PsysGridMap1.TotalCellsY = 19;
            PsysGridMap1.CellWidth = 35;
            PsysGridMap1.CellHeight = 35;
            PsysGridMap1.RemoveAllCells();
            PsysGridMap1.MapBackgroundImage = imgBeach;
            PsysGridMap1.ForeColor = System.Drawing.Color.Black;
            PsysGridMap1.CellsTitleAlign = ContentAlignment.TopLeft;
            Font f = new System.Drawing.Font(this.Font.FontFamily, 8);
            PsysGridMap1.CellsFont = f;

            //### Load a BackgroundMap from a JSON string ###
            string jStr = "";
            jStr = jStr + "{" + NwLn;
            jStr = jStr + "  \"Type\": \"BackGroundMap\"," + NwLn;
            jStr = jStr + "  \"Items\": [" + NwLn;
            jStr = jStr + "    {\"IniPosX\": 1, \"IniPosY\": 19,  \"EndPosX\": 28,  \"EndPosY\": 19,  \"BackColorHTML\": \"#dddddd\"}," + NwLn;
            jStr = jStr + "    {\"IniPosX\": 16, \"IniPosY\": 17, \"EndPosX\": 27, \"EndPosY\": 18, \"BackColorHTML\": \"#A97735\"}" + NwLn;
            jStr = jStr + "  ]" + NwLn;
            jStr = jStr + "}" + NwLn;
            PsysGridMap1.BackgroundMapJSON = jStr;

            Color cYellow = System.Drawing.Color.FromArgb(180, 200, 200, 0);
            Color cRed = System.Drawing.Color.FromArgb(180, 200, 0, 0);
            Color cGreen = System.Drawing.Color.FromArgb(180, 0, 200, 0);
            int iCornSize = 12;

            ClsPsysCell oCell = new ClsPsysCell();

            int IdPos = 0;
            int yy = 0;
            int xx = 0;
            for (yy = 5; yy <= 17; yy++)
            {
                for (xx = 2; xx <= 12; xx += 2)
                {
                    IdPos += 1;
                    oCell = new ClsPsysCell();
                    oCell = PsysGridMap1.SetCell(IdPos, xx, yy, IdPos.ToString());
                    oCell.CellBackColor = System.Drawing.Color.FromArgb(0, 0, 0, 0); ;
                    oCell.CellBackgroundImage = imgPosAzure;
                    oCell.CellBackgroundImagePosition = ContentAlignment.BottomRight;
                    oCell.CornerNote = true;
                    oCell.CornerColor = cGreen;
                    oCell.CornerPosition = ClsPsysCell.EnumCornerPosition.RightTop;
                    oCell.CornerSize = iCornSize;
                }
            }

            for (yy = 6; yy <= 7; yy++)
            {
                for (xx = 16; xx <= 21; xx++)
                {
                    IdPos += 1;
                    oCell = new ClsPsysCell();
                    oCell = PsysGridMap1.SetCell(IdPos, xx, yy, IdPos.ToString());
                    oCell.CellBackColor = System.Drawing.Color.FromArgb(0, 0, 0, 0); ;
                    oCell.CellBackgroundImage = imgLettino;
                    oCell.CellBackgroundImagePosition = ContentAlignment.BottomRight;
                    oCell.CornerNote = true;
                    oCell.CornerColor = cGreen;
                    oCell.CornerPosition = ClsPsysCell.EnumCornerPosition.RightTop;
                    oCell.CornerSize = iCornSize;
                }
            }

            for (yy = 9; yy <= 15; yy+=2)
            {
                for (xx = 16; xx <= 27; xx++)
                {
                    IdPos += 1;
                    oCell = new ClsPsysCell();
                    oCell = PsysGridMap1.SetCell(IdPos, xx, yy, IdPos.ToString());
                    oCell.CellBackColor = System.Drawing.Color.FromArgb(0, 0, 0, 0); ;
                    oCell.CellBackgroundImage = imgPosYellow;
                    oCell.CellBackgroundImagePosition = ContentAlignment.BottomRight;
                    oCell.CornerNote = true;
                    oCell.CornerColor = cGreen;
                    oCell.CornerPosition = ClsPsysCell.EnumCornerPosition.RightTop;
                    oCell.CornerSize = iCornSize;
                }
            }

            int i = 0;
            for (i = 1; i <= 50; i++)
            {
                int myId = rnd.Next(80) + 1;
                oCell = new ClsPsysCell();
                oCell = PsysGridMap1.GetCell(myId);
                oCell.CornerNote = true;
                oCell.CornerColor = cRed;
                oCell.CornerPosition = ClsPsysCell.EnumCornerPosition.RightTop;
                oCell.CornerSize = iCornSize;
            }

            for (i = 1; i <= 20; i++)
            {
                int myId = rnd.Next(80) + 1;
                oCell = new ClsPsysCell();
                oCell = PsysGridMap1.GetCell(myId);
                oCell.CornerNote = true;
                oCell.CornerColor = cYellow;
                oCell.CornerPosition = ClsPsysCell.EnumCornerPosition.RightTop;
                oCell.CornerSize = iCornSize;
            }

            PsysGridMap1.Redraw();

        }

        private void PsysGridMap1_CellClick(object sender, EventArgs e)
        {
            PsysCellsEventArgs CellArgs = e as PsysCellsEventArgs;
            if (CellArgs == null) {
                return;
            }

            string sInfo = "";
            sInfo += "Cell: (X:" + CellArgs.CellX.ToString() + ",Y:" + CellArgs.CellY.ToString() + ")";
            sInfo += " - ";
            sInfo += "Mouse: (X:" + CellArgs.MouseX.ToString() + ",Y:" + CellArgs.MouseY.ToString() + ")";
            txtCellInfo.Text = sInfo;
        }

        private void PsysGridMap1_CellDoubleClick(object sender, EventArgs e)
        {

            PsysCellsEventArgs CellArgs = e as PsysCellsEventArgs;
            if (CellArgs == null)
            {
                return;
            }

            ClsPsysCell newCell = new ClsPsysCell();
            newCell.ID = CellArgs.CellX.ToString() + "," + CellArgs.CellY.ToString();
            newCell.CellX = CellArgs.CellX;
            newCell.CellY = CellArgs.CellY;
            newCell.CellBackColor = Color.Yellow;
            newCell.CornerNote = true;
            newCell.CornerPosition = EnumCornerPosition.LeftTop;
            newCell.CornerColor = Color.Red;
            newCell.Title = CellArgs.CellX.ToString() + "," + CellArgs.CellY.ToString();
            newCell.CornerSize = 10;

            PsysGridMap1.SetCell(newCell);
            PsysGridMap1.Redraw();

        }

        private void PsysGridMap1_Dragging(object sender, EventArgs e)
        {
            PsysCellsEventArgs CellArgs = e as PsysCellsEventArgs;
            if (CellArgs == null)
            {
                return;
            }

            ClsPsysCell newCell = new ClsPsysCell();
            newCell.ID = CellArgs.CellX.ToString() + "," + CellArgs.CellY.ToString();
            newCell.CellX = CellArgs.CellX;
            newCell.CellY = CellArgs.CellY;
            newCell.CellBackColor = Color.GreenYellow;
            newCell.CornerNote = true;
            newCell.CornerPosition = EnumCornerPosition.RightTop;
            newCell.CornerColor = Color.White;
            newCell.Title = CellArgs.CellX.ToString() + "," + CellArgs.CellY.ToString();
            newCell.CornerSize = 12;

            PsysGridMap1.SetCell(newCell);
            PsysGridMap1.Redraw();

        }
    }
}
